const Model = require('./model');

class GridModel extends Model {
    constructor(numDiv, delta) {
        super();

        this._numDiv = numDiv;
        this._delta = delta;
        this._adaptative = false;
    }

    // Grid setters.
    set numDiv(value) { this._numDiv = value; /*PubSub.publish('change-grid', 0);*/ }
    set delta(value) { this._delta = value; /*PubSub.publish('change-grid', 0);*/ }
    set adaptative(value) { this._adaptative = value; /*PubSub.publish('change-grid', 0);*/ }

    // Grid getters.
    get numDiv() { return this._numDiv; }
    get delta() { return this._delta; }
    get adaptative() { return this._adaptative; }

    /**
     * Set all grid parameters.
     */
    setGrid(numDiv, delta, adaptative) {
        this._numDiv = numDiv;
        this._delta = delta;
        this._adaptative = adaptative;

        //PubSub.publish('change-grid', 0);
    }

    toObject() {
        return {
            numDiv: this._numDiv,
            delta: this._delta,
            adaptative: this.adaptative
        };
    }

    /**
     * Save the model data into a config object (the saver object).
     */
    save(saver) {
        saver.grid = this.toObject();
    }

    /**
     * Restore the model state saved in the saver object (the configuration object).
     */
    restore(saver) {
        let grid = saver.grid;
        this._numDiv = grid.numDiv;
        this._delta = grid.delta;
        this._adaptative = grid.adaptative;

        //PubSub.publish('change-grid', 0);
    }
}

module.exports = GridModel;