/**
 * Not used.
 */
class DiffractionLattice {

    /**
     * Construct a new Diffraction Lattice
     *
     * @param d lattice spacing
     * @param angle_theta Bragg Angle in radians
     */
    constructor(d, theta) {
        /**
         * d is the lattice spacing within the crystal
         */
        this._d = d;

        /**
         * Angle theta is the Bragg angles
         */
        this._theta = new Angle(theta);

        /**
         * Wavelength Lambda is the wavelength of the beam emitted from the lattice
         */
        this._lambda = Wavelength.createFromAngstroms(2 * d * theta.sin());
    }

    /**
     * Get the wavelength of the beam emitted from the lattice
     *
     * @return
     */
    get lambda() {
        return this._lambda;
    }

    /**
     * Set the wavelength of the lattice
     *
     * @param lambda
     */
    set lambda(lambda) {
        this._lambda = lambda;
        this.theta = new Angle(Math.asin(this._lambda.angstromValue / (2 * this._d)));

    }
}