const Model = require('./model');

class PeaksModel extends Model {
    constructor(lowX, lowY, lowZ, upperX, upperY, upperZ, sphereOpacity) {
        super();

        this._lowX = lowX;
        this._lowY = lowY;
        this._lowZ = lowZ;
        this._upperX = upperX;
        this._upperY = upperY;
        this._upperZ = upperZ;
        this._sphereOpacity = sphereOpacity;
    }

    // Peaks setters
    set lowX(value) { this._lowX = value; }
    set lowY(value) { this._lowY = value; }
    set lowZ(value) { this._lowZ = value; }
    set upperX(value) { this._upperX = value; }
    set upperY(value) { this._upperY = value; }
    set upperZ(value) { this._upperZ = value; }
    set sphereOpacity(value) { this._sphereOpacity = value; }

    // Peaks getters
    get lowX() { return this._lowX; }
    get lowY() { return this._lowY; }
    get lowZ() { return this._lowZ; }
    get upperX() { return this._upperX; }
    get upperY() { return this._upperY; }
    get upperZ() { return this._upperZ; }
    get sphereOpacity() { return this._sphereOpacity; }

    /**
     * Set all peaks bounds value.
     */
    setPeaks(lowX, lowY, lowZ, upperX, upperY, upperZ, sphereOpacity) {
        this.lowX = lowX;
        this.lowY = lowY;
        this.lowZ = lowZ;
        this.upperX = upperX;
        this.upperY = upperY;
        this.upperZ = upperZ;
        this.sphereOpacity = sphereOpacity;
    }

    toObject() {
        return {
            lowX: this._lowX,
            lowY: this._lowY,
            lowZ: this._lowZ,
            upperX: this._upperX,
            upperY: this._upperY,
            upperZ: this._upperZ,
            sphereOpacity: this._sphereOpacity
        };
    }

    /**
     * Save the model data into a config object (the saver object).
     */
    save(saver) {
        saver.peaks = this.toObject();
    }

    /**
     * Restore the model state saved in the saver object (the configuration object).
     */
    restore(saver) {
        let peaks = saver.peaks;

        this._lowX = peaks.lowX;
        this._lowY = peaks.lowY;
        this._lowZ = peaks.lowZ;
        this._upperX = peaks.upperX;
        this._upperY = peaks.upperY;
        this._upperZ = peaks.upperZ;
        this._sphereOpacity = peaks.sphereOpacity;
    }
}

module.exports = PeaksModel;